<!-- table -->
<app-table
  (pagingChange)="emitPagingChange($event)"
  (sortChange)="emitSortsChange()"
  [columns]="columns"
  [loading]="loading"
  [page]="page"
  [rows]="data"
  [size]="size"
  [loadLabel]="loadMoreLable"
  [total]="total"
>
  <!-- toolkit column -->
  <ng-template appTableBodyCell columnProperty="empty" let-user="row">
    <!-- activity -->
    <div class="app-map">
      <!-- actions icon -->
      <app-more-options #more class="dh ms">
        <!-- recent device access -->
        <button (click)="openAccessHistory(user); more.close()" appIconButton>
          <!-- lock -->
          <app-icon-lock-small></app-icon-lock-small>
          Recent Device Access
        </button>

        <!-- recent activity -->
        <button (click)="openActivityHistory(user); more.close()" appIconButton>
          <!-- line chart -->
          <app-icon-line-chart></app-icon-line-chart>
          Recent Activity
        </button>

        <ng-container *ngIf="editPermission$ | async">
          <!-- divider -->
          <div class="app-divider"></div>

          <!-- edit -->
          <button (click)="openEditAdmin(user); more.close()" appIconButton>
            <!-- pencil -->
            <app-icon-pencil></app-icon-pencil>
            Edit
          </button>

          <!-- delete -->
          <button (click)="openDeleteConfirmModal(user); more.close()" appIconButton>
            <!-- delete -->
            <app-icon-delete></app-icon-delete>
            Delete
          </button>
        </ng-container>
      </app-more-options>
    </div>
    <app-icon-toolkit-reverse class="dh"></app-icon-toolkit-reverse>
    <!-- toolkit icon -->
    <app-tooltip class="ds mh" *ngIf="user.toolkit" position="top">
      <app-icon-toolkit-reverse></app-icon-toolkit-reverse>
      <b tooltip>
        Toolkit User
      </b>
    </app-tooltip>
  </ng-template>

  <!-- name column -->
  <ng-template appTableBodyCell columnProperty="name" let-user="row">
    <!-- show user info for name column -->
    <app-user-info
      (nameClick)="openAdminInfo($event)"
      [clickable]="true"
      [tooltipVisible]="true"
      [user]="user"
      type="email"
    ></app-user-info>
  </ng-template>

  <!-- state column -->
  <ng-template appTableBodyCell columnProperty="state" let-user="row">
    <span class="column-label dh ms">STATE</span>
    <!-- show state label for state column -->
    <app-state-label
      [disabledReason]="user.disabledReason"
      [state]="user.state"
      [status]="user.status"
      type="admin"
    ></app-state-label>
  </ng-template>

  <!-- permissions column -->
  <ng-template appTableBodyCell columnProperty="permissions" let-permissions="value" let-user="row">
    <!-- show permission editor -->
    <app-permission-editor [user]="user" [permissions]="permissions"></app-permission-editor>
  </ng-template>

  <!-- toolkit column -->
  <ng-template appTableBodyCell columnProperty="toolkit" let-toolkit="value">
    <span class="column-label dh ms">TOOLKIT SN</span>
    <!-- toolkit -->
    <ng-container *ngIf="toolkit; else notAvailable">
      <div class="app-toolkit-sn">
        {{ toolkit.sn }}
      </div>

      <div class="app-toolkit-pin">
        PIN: <span>{{ toolkit.pin }}</span>
      </div>
    </ng-container>

    <!-- N/A -->
    <ng-template #notAvailable>
      <span class="app-toolkit-na">N/A</span>
    </ng-template>
  </ng-template>

  <!-- recent activity column -->
  <ng-template appTableBodyCell columnProperty="recentActivity" let-user="row">
    <span class="column-label dh ms">RECENT ACTIVITY</span>
    <!-- show recent activity -->
    <!-- activity -->
    <div class="app-activity">
      <ng-container *ngIf="user.recentActivity">
        <!-- left -->
        <div class="app-left">
          <!-- activity -->
          <div>
            {{ user.recentActivity.activity }}
          </div>

          <!-- view more -->
          <a (click)="openActivityHistory(user)" class="app-link">
            VIEW MORE
          </a>
        </div>
      </ng-container>

      <!-- actions icon -->
      <app-more-options #more class="ds mh">
        <!-- recent device access -->
        <button
          (click)="openAccessHistory(user); more.close()"
          *ngIf="accessHistoryReadPermission$ | async"
          appIconButton
        >
          <!-- lock -->
          <app-icon-lock-small></app-icon-lock-small>
          Recent Device Access
        </button>

        <!-- recent activity -->
        <button (click)="openActivityHistory(user); more.close()" appIconButton>
          <!-- line chart -->
          <app-icon-line-chart></app-icon-line-chart>
          Recent Activity
        </button>

        <ng-container *ngIf="editPermission$ | async">
          <!-- divider -->
          <div class="app-divider"></div>

          <!-- edit -->
          <button (click)="openEditAdmin(user); more.close()" appIconButton>
            <!-- pencil -->
            <app-icon-pencil></app-icon-pencil>
            Edit
          </button>

          <!-- delete -->
          <button (click)="openDeleteConfirmModal(user); more.close()" appIconButton>
            <!-- delete -->
            <app-icon-delete></app-icon-delete>
            Delete
          </button>
        </ng-container>
      </app-more-options>
    </div>
  </ng-template>
</app-table>

<!-- admin info -->
<app-side-modal-admin-info
  (updated)="onInfoUpdated()"
  (closeClick)="closeAdminInfo()"
  *ngIf="adminInfoVisible"
  [user]="selectedAdmin"
></app-side-modal-admin-info>

<!-- access history -->
<app-side-modal-access-history
  (closeClick)="closeAccessHistory()"
  *ngIf="accessHistoryVisible"
  [user]="selectedAdmin"
  type="keyholder"
></app-side-modal-access-history>

<!-- activity history -->
<app-side-modal-activity-history
  (closeClick)="closeActivityHistory()"
  *ngIf="activityHistoryVisible"
  [user]="selectedAdmin"
></app-side-modal-activity-history>

<!-- delete confirm -->
<app-delete-modal
  (closeClick)="closeDeleteConfirmModal()"
  (confirmClick)="deleteAdmin()"
  *ngIf="deleteModalVisible"
  [loading]="deleteLoading"
>
  Are you sure want to delete Administrator {{ selectedAdmin.id }} ?
</app-delete-modal>
